## jackd2 1.9.19~dfsg

=== wscript ===
#! /usr/bin/python3
# encoding: utf-8
from __future__ import print_function

import os
import subprocess
import shutil
import re
import sys

from waflib import Logs, Options, Task, Utils
from waflib.Build import BuildContext, CleanContext, InstallContext, UninstallContext

VERSION='1.9.19'
APPNAME='jack'
JACK_API_VERSION = '0.1.0'

# these variables are mandatory ('/' are converted automatically)
top = '.'
out = 'build'

# lib32 variant name used when building in mixed mode
lib32 = 'lib32'

def display_feature(conf, msg, build):
    if build:
        conf.msg(msg, 'yes', color='GREEN')
    else:
        conf.msg(msg, 'no', color='YELLOW')

def check_for_celt(conf):
    found = False
    for version in ['11', '8', '7', '5']:
        define = 'HAVE_CELT_API_0_' + version
        if not found:
            try:
                conf.check_cfg(
                        package='celt >= 0.%s.0' % version,
                        args='--cflags --libs')
                found = True
                conf.define(define, 1)
                continue
            except conf.errors.ConfigurationError:
                pass
        conf.define(define, 0)

    if not found:
        raise conf.errors.ConfigurationError

def options(opt):
    # options provided by the modules
    opt.load('compiler_cxx')
    opt.load('compiler_c')
    opt.load('autooptions');

    opt.load('xcode6')

    opt.recurse('compat')

    # install directories
    opt.add_option('--htmldir', type='string', default=None, help='HTML documentation directory [Default: <prefix>/share/jack-audio-connection-kit/reference/html/')
    opt.add_option('--libdir', type='string', help='Library directory [Default: <prefix>/lib]')
    opt.add_option('--libdir32', type='string', help='32bit Library directory [Default: <prefix>/lib32]')
    opt.add_option('--pkgconfigdir', type='string', help='pkg-config file directory [Default: <libdir>/pkgconfig]')
    opt.add_option('--mandir', type='string', help='Manpage directory [Default: <prefix>/share/man/man1]')

    # options affecting binaries
    opt.add_option('--platform', type='string', default=sys.platform, help='Target platform for cross-compiling, e.g. cygwin or win32')
    opt.add_option('--mixed', action='store_true', default=False, help='Build with 32/64 bits mixed mode')
    opt.add_option('--debug', action='store_true', default=False, dest='debug', help='Build debuggable binaries')
    opt.add_option('--static', action='store_true', default=False, dest='static', help='Build static binaries (Windows only)')

    # options affecting general jack functionality
    opt.add_option('--classic', action='store_true', default=False, help='Force enable standard JACK (jackd) even if D-Bus JACK (jackdbus) is enabled too')
    opt.add_option('--dbus', action='store_true', default=False, help='Enable D-Bus JACK (jackdbus)')
    opt.add_option('--autostart', type='string', default='default', help='Autostart method. Possible values: "default", "classic", "dbus", "none"')
    opt.add_option('--profile', action='store_true', default=False, help='Build with engine profiling')
    opt.add_option('--clients', default=256, type='int', dest='clients', help='Maximum number of JACK clients')
    opt.add_option('--ports-per-application', default=2048, type='int', dest='application_ports', help='Maximum number of ports per application')
    opt.add_option('--systemd-unit', action='store_true', default=False, help='Install systemd units.')

    opt.set_auto_options_define('HAVE_%s')
    opt.set_auto_options_style('yesno_and_hack')

    # options with third party dependencies
    doxygen = opt.add_auto_option(
            'doxygen',
            help='Build doxygen documentation',
            conf_dest='BUILD_DOXYGEN_DOCS',
            default=False)
    doxygen.find_program('doxygen')
    alsa = opt.add_auto_option(
            'alsa',
            help='Enable ALSA driver',
            conf_dest='BUILD_DRIVER_ALSA')
    alsa.check_cfg(
            package='alsa >= 1.0.18',
            args='--cflags --libs')
    firewire = opt.add_auto_option(
            'firewire',
            help='Enable FireWire driver (FFADO)',
            conf_dest='BUILD_DRIVER_FFADO')
    firewire.check_cfg(
            package='libffado >= 1.999.17',
            args='--cflags --libs')
    iio = opt.add_auto_option(
            'iio',
            help='Enable IIO driver',
            conf_dest='BUILD_DRIVER_IIO')
    iio.check_cfg(
            package='gtkIOStream >= 1.4.0',
            args='--cflags --libs')
    iio.check_cfg(
            package='eigen3 >= 3.1.2',
            args='--cflags --libs')
    portaudio = opt.add_auto_option(
            'portaudio',
            help='Enable Portaudio driver',
            conf_dest='BUILD_DRIVER_PORTAUDIO')
    portaudio.check(header_name='windows.h') # only build portaudio on windows
    portaudio.check_cfg(
            package='portaudio-2.0 >= 19',
            uselib_store='PORTAUDIO',
            args='--cflags --libs')
    winmme = opt.add_auto_option(
            'winmme',
            help='Enable WinMME driver',
            conf_dest='BUILD_DRIVER_WINMME')
    winmme.check(
            header_name=['windows.h', 'mmsystem.h'],
            msg='Checking for header mmsystem.h')

    celt = opt.add_auto_option(
            'celt',
            help='Build with CELT')
    celt.add_function(check_for_celt)

    # Suffix _PKG to not collide with HAVE_OPUS defined by the option.
    opus = opt.add_auto_option(
            'opus',
            help='Build Opus netjack2')
    opus.check(header_name='opus/opus_custom.h')
    opus.check_cfg(
            package='opus >= 0.9.0',
            args='--cflags --libs',
            define_name='HAVE_OPUS_PKG')

    samplerate = opt.add_auto_option(
            'samplerate',
            help='Build with libsamplerate')
    samplerate.check_cfg(
            package='samplerate',
            args='--cflags --libs')
    sndfile = opt.add_auto_option(
            'sndfile',
            help='Build with libsndfile')
    sndfile.check_cfg(
            package='sndfile',
            args='--cflags --libs')
    readline = opt.add_auto_option(
            'readline',
            help='Build with readline')
    readline.check(lib='readline')
    readline.check(
            header_name=['stdio.h', 'readline/readline.h'],
            msg='Checking for header readline/readline.h')
    sd = opt.add_auto_option(
            'systemd',
            help='Use systemd notify')
    sd.check(header_name='systemd/sd-daemon.h')
    sd.check(lib='systemd')
    db = opt.add_auto_option(
            'db',
            help='Use Berkeley DB (metadata)')
    db.check(header_name='db.h')
    db.check(lib='db')
    zalsa = opt.add_auto_option(
            'zalsa',
            help='Build internal zita-a2j/j2a client')
    zalsa.check(lib='zita-alsa-pcmi')
    zalsa.check(lib='zita-resampler')

    # dbus options
    opt.recurse('dbus')

    # this must be called before the configure phase
    opt.apply_auto_options_hack()

def detect_platform(conf):
    # GNU/kFreeBSD and GNU/Hurd are treated as Linux
    platforms = [
        # ('KEY, 'Human readable name', ['strings', 'to', 'check', 'for'])
        ('IS_LINUX',   'Linux',   ['gnu0', 'gnukfreebsd', 'linux', 'posix']),
        ('IS_MACOSX',  'MacOS X', ['darwin']),
        ('IS_SUN',     'SunOS',   ['sunos']),
        ('IS_WINDOWS', 'Windows', ['cygwin', 'msys', 'win32'])
    ]

    for key,name,strings in platforms:
        conf.env[key] = False

    conf.start_msg('Checking platform')
    platform = Options.options.platform
    for key,name,strings in platforms:
        for s in strings:
            if platform.startswith(s):
                conf.env[key] = True
                conf.end_msg(name, color='CYAN')
                break


def configure(conf):
    conf.load('compiler_cxx')
    conf.load('compiler_c')

    detect_platform(conf)

    if conf.env['IS_WINDOWS']:
        conf.env.append_unique('CCDEFINES', '_POSIX')
        conf.env.append_unique('CXXDEFINES', '_POSIX')
        if Options.options.platform == 'msys':
            conf.env.append_value('INCLUDES', ['/mingw64/include'])
            conf.check(
                header_name='asio.h',
                includes='/opt/asiosdk/common',
                msg='Checking for ASIO SDK',
                define_name='HAVE_ASIO',
                mandatory=False)

    conf.env.append_unique('CFLAGS', '-Wall')
    conf.env.append_unique('CXXFLAGS', ['-Wall', '-Wno-invalid-offsetof'])
    conf.env.append_unique('CXXFLAGS', '-std=gnu++11')

    if not conf.env['IS_MACOSX']:
        conf.env.append_unique('LDFLAGS', '-Wl,--no-undefined')
    else:
        conf.check(lib='aften', uselib='AFTEN', define_name='AFTEN')
        conf.check_cxx(
            fragment=''
                + '#include <aften/aften.h>\n'
                + 'int\n'
                + 'main(void)\n'
                + '{\n'
                + 'AftenContext fAftenContext;\n'
                + 'aften_set_defaults(&fAftenContext);\n'
                + 'unsigned char *fb;\n'
                + 'float *buf=new float[10];\n'
                + 'int res = aften_encode_frame(&fAftenContext, fb, buf, 1);\n'
                + '}\n',
            lib='aften',
            msg='Checking for aften_encode_frame()',
            define_name='HAVE_AFTEN_NEW_API',
            mandatory=False)

        # TODO
        conf.env.append_unique('CXXFLAGS', '-Wno-deprecated-register')

    conf.load('autooptions')

    conf.recurse('compat')

    # Check for functions.
    conf.check(
            fragment=''
                + '#define _GNU_SOURCE\n'
                + '#include <poll.h>\n'
                + '#include <signal.h>\n'
                + '#include <stddef.h>\n'
                + 'int\n'
                + 'main(void)\n'
                + '{\n'
                + '   ppoll(NULL, 0, NULL, NULL);\n'
                + '}\n',
            msg='Checking for ppoll',
            define_name='HAVE_PPOLL',
            mandatory=False)

    # Check for backtrace support
    conf.check(
        header_name='execinfo.h',
        define_name='HAVE_EXECINFO_H',
        mandatory=False)

    conf.recurse('common')
    if Options.options.dbus:
        conf.recurse('dbus')
        if conf.env['BUILD_JACKDBUS'] != True:
            conf.fatal('jackdbus was explicitly requested but cannot be built')
    if conf.env['IS_LINUX']:
        if Options.options.systemd_unit:
            conf.recurse('systemd')
        else:
            conf.env['SYSTEMD_USER_UNIT_DIR'] = None


    conf.recurse('example-clients')
    conf.recurse('tools')

    # test for the availability of ucontext, and how it should be used
    for t in ['gp_regs', 'uc_regs', 'mc_gregs', 'gregs']:
        fragment = '#include <ucontext.h>\n'
        fragment += 'int main() { ucontext_t *ucontext; return (int) ucontext->uc_mcontext.%s[0]; }' % t
        confvar = 'HAVE_UCONTEXT_%s' % t.upper()
        conf.check_cc(fragment=fragment, define_name=confvar, mandatory=False,
                      msg='Checking for ucontext->uc_mcontext.%s' % t)
        if conf.is_defined(confvar):
            conf.define('HAVE_UCONTEXT', 1)

    fragment = '#include <ucontext.h>\n'
    fragment += 'int main() { return NGREG; }'
    conf.check_cc(fragment=fragment, define_name='HAVE_NGREG', mandatory=False,
                  msg='Checking for NGREG')

    conf.env['LIB_PTHREAD'] = ['pthread']
    conf.env['LIB_DL'] = ['dl']
    conf.env['LIB_RT'] = ['rt']
    conf.env['LIB_M'] = ['m']
    conf.env['LIB_STDC++'] = ['stdc++']
    conf.env['JACK_API_VERSION'] = JACK_API_VERSION
    conf.env['JACK_VERSION'] = VERSION

    conf.env['BUILD_WITH_PROFILE'] = Options.options.profile
    conf.env['BUILD_WITH_32_64'] = Options.options.mixed
    conf.env['BUILD_CLASSIC'] = Options.options.classic
    conf.env['BUILD_DEBUG'] = Options.options.debug
    conf.env['BUILD_STATIC'] = Options.options.static

=== tools/wscript ===
#! /usr/bin/python3
# encoding: utf-8

example_tools = {
    'jack_alias' : 'alias.c',
    'jack_bufsize' : 'bufsize.c',
    'jack_connect' : 'connect.c',
    'jack_evmon' : 'evmon.c',
    'jack_freewheel' : 'freewheel.c',
    'jack_load' : 'ipload.c',
    'jack_lsp' : 'lsp.c',
    'jack_midi_dump' : 'midi_dump.c',
    'jack_monitor_client' : 'monitor_client.c',
    'jack_property' : 'property.c',
    'jack_samplerate' : 'samplerate.c',
    'jack_session_notify' : 'session_notify.c',
    'jack_unload' : 'ipunload.c',
    'jack_wait' : 'wait.c',
    }

def configure(conf):
    conf.env['BUILD_TOOL_ALSA_IO'] = conf.env['SAMPLERATE'] and conf.env['BUILD_DRIVER_ALSA']
    conf.env['BUILD_TOOL_CLIENT_TRANSPORT'] = conf.env['READLINE']
    conf.env['BUILD_TOOL_ZALSA'] = conf.env['ZALSA']

def build(bld):
    if bld.env['IS_LINUX']:
        os_incdir = ['../linux', '../posix']
    if bld.env['IS_MACOSX']:
        os_incdir = ['../macosx', '../posix']
    if bld.env['IS_SUN']:
        os_incdir = ['../solaris', '../posix']
    if bld.env['IS_WINDOWS']:
        os_incdir = ['../windows']
    for example_tool, example_tool_source in list(example_tools.items()):
        if bld.env['IS_MACOSX']:
            prog = bld(features='c cprogram', framework = ['Foundation'])
        else:
            prog = bld(features='c cprogram')
        prog.includes = os_incdir + ['../common/jack', '../common']
        prog.source = example_tool_source
        prog.use = ['clientlib']
        if bld.env['IS_LINUX']:
            prog.use += ['RT', 'M']
        if bld.env['IS_SUN']:
            prog.use += ['M']
        if bld.env['IS_WINDOWS'] and bld.env['BUILD_STATIC']:
            prog.env['LIB_PTHREAD'] = [':libwinpthread.a']
        #prog.cflags = ['-Wno-deprecated-declarations', '-Wno-misleading-indentation']
        #prog.cxxflags = ['-Wno-deprecated-declarations', '-Wno-misleading-indentation']

        prog.target = example_tool

    if bld.env['BUILD_TOOL_CLIENT_TRANSPORT']:
        prog = bld(features = 'c cprogram')
        prog.includes = os_incdir + ['../common/jack', '../common']
        prog.source = 'transport.c'
        prog.use = ['clientlib']
        if bld.env['IS_LINUX']:
            prog.use += ['RT', 'READLINE']
        if bld.env['IS_MACOSX']:
            prog.use += ['READLINE']
        if bld.env['IS_WINDOWS']:
            prog.use += ['READLINE']
            if bld.env['BUILD_STATIC']:
                prog.env['LIB_PTHREAD'] = [':libwinpthread.a']
        prog.target = 'jack_transport'

    if bld.env['IS_LINUX'] or bld.env['IS_MACOSX']:
        prog = bld(features = 'c cprogram')
        prog.includes = os_incdir + ['.', '..', '../common/jack', '../common']
        prog.source = ['netsource.c', '../common/netjack_packet.c']
        prog.env.append_value('CFLAGS', '-DNO_JACK_ERROR')
        prog.use = ['CELT', 'SAMPLERATE', 'OPUS', 'M', 'clientlib']
        prog.target = 'jack_netsource'
        prog.defines = ['HAVE_CONFIG_H']

    if bld.env['IS_LINUX'] and bld.env['BUILD_TOOL_ALSA_IO']:
        prog = bld(features = 'c cprogram')
        prog.includes = os_incdir + ['../common/jack', '../common']
        prog.source = ['alsa_in.c', '../common/memops.c']
        prog.env.append_value('CFLAGS', '-DNO_JACK_ERROR')
        prog.use = ['clientlib', 'ALSA', 'SAMPLERATE', 'M']
        prog.target = 'alsa_in'

        prog = bld(features = 'c cprogram')
        prog.includes = os_incdir + ['../common/jack', '../common']
        prog.source = ['alsa_out.c', '../common/memops.c']
        prog.env.append_value('CFLAGS', '-DNO_JACK_ERROR')
        prog.use = ['clientlib', 'ALSA', 'SAMPLERATE', 'M']
        prog.target = 'alsa_out'

    if bld.env['IS_LINUX'] and bld.env['BUILD_TOOL_ZALSA']:
        prog = bld(features = ['cxx', 'cxxshlib'])
        prog.defines = ['HAVE_CONFIG_H','SERVER_SIDE','APPNAME="zalsa_in"','VERSION="0.4.0"']
        prog.install_path = '${ADDON_DIR}/'
        prog.includes = os_incdir + ['../common/jack', '../common', 'zalsa']
        prog.source = ['zalsa/zita-a2j.cc', 'zalsa/alsathread.cc', 'zalsa/jackclient.cc', 'zalsa/pxthread.cc', 'zalsa/lfqueue.cc']
        prog.target = 'zalsa_in'
        prog.use = ['ZITA-ALSA-PCMI', 'ZITA-RESAMPLER', 'ALSA', 'M', 'RT', 'serverlib']
        prog.env['cxxshlib_PATTERN'] = '%s.so'

        prog = bld(features = ['cxx', 'cxxshlib'])
        prog.defines = ['HAVE_CONFIG_H','SERVER_SIDE','APPNAME="zalsa_out"','VERSION="0.4.0"']
        prog.install_path = '${ADDON_DIR}/'
        prog.includes = os_incdir + ['../common/jack', '../common', 'zalsa']
        prog.source = ['zalsa/zita-j2a.cc', 'zalsa/alsathread.cc', 'zalsa/jackclient.cc', 'zalsa/pxthread.cc', 'zalsa/lfqueue.cc']
        prog.target = 'zalsa_out'
        prog.use = ['ZITA-ALSA-PCMI', 'ZITA-RESAMPLER', 'ALSA', 'M', 'RT', 'serverlib']
        prog.env['cxxshlib_PATTERN'] = '%s.so'

    if not bld.env['IS_WINDOWS']:
        bld.symlink_as('${PREFIX}/bin/jack_disconnect', 'jack_connect')
        bld.install_files('${PREFIX}/bin', 'jack_control', chmod=0o755)

=== debian/changelog ===
jackd2 (1.9.19~dfsg-2ubuntu1) impish; urgency=medium

  * Build without LTO to prevent runtime crash

 -- Erich Eickmeyer <eeickmeyer@ubuntu.com>  Mon, 06 Sep 2021 14:40:18 -0700

jackd2 (1.9.19~dfsg-2) unstable; urgency=medium

  * Team upload
  * debian/:
    - Convert to debhelper compat 13
    - Filter linux-any specific files using dh-exec
    - Fix FTCBFS (Closes: #912907)
  * debian/control: Remove obsolete Depends and Replaces
  * debian/copyright: Clean up copyright file and merge paragraphs
  * debian/patches: Remove unused patch
  * debian/libjack-jackd2-0.lintian-overrides: Fix lintian tag name

 -- Sebastian Ramacher <sramacher@debian.org>  Thu, 02 Sep 2021 13:35:50 +0200

jackd2 (1.9.19~dfsg-1) unstable; urgency=medium

  * Team upload

  [ Erich Eickmeyer ]
  * Add libdb-dev is a build dependency for metadata per upstream (Closes:
    #985050)

  [ Sebastian Ramacher ]
  * New upstream release
  * debian/copyright:
    - Remove bogus paragraphs
    - Add new paragraph for zalsa
  * debian/copyright: Bump Standards-Version
  * debian/: Build with zalsa client
  * debian/jackd2.maintscript: Remove now obsolete rm_conffile

 -- Sebastian Ramacher <sramacher@debian.org>  Thu, 02 Sep 2021 00:31:19 +0200

=== debian/control ===
Source: jackd2
Section: sound
Priority: optional
Maintainer: Erich Eickmeyer <eeickmeyer@ubuntu.com>
XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders: Adrian Knoth <adi@drcomp.erfurt.thur.de>,
           Reinhard Tartler <siretart@tauware.de>
Build-Depends: debhelper-compat (= 13),
               dh-exec,
               dh-sequence-python3,
               libasound2-dev (>= 1.0.18) [linux-any],
               libdb-dev,
               libdbus-1-dev,
               libexpat1-dev,
               libffado-dev (>= 2.0.0) [linux-any],
               libncurses-dev,
               libopus-dev,
               libraw1394-dev [linux-any],
               libreadline-dev,
               libsamplerate-dev,
               libsndfile1-dev,
               libsystemd-dev [linux-any],
               libzita-alsa-pcmi-dev,
               libzita-resampler-dev,
               po-debconf,
               python3:any
Standards-Version: 4.6.0
Rules-Requires-Root: no
Homepage: https://jackaudio.org/
Vcs-Git: https://salsa.debian.org/multimedia-team/jackd2.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/jackd2

Package: jackd2
Architecture: any
Replaces: jack-daemon, jackd (<< 3), libjack0 (<= 1.9.5~dfsg-13)
Provides: jack-daemon
Conflicts: jack-daemon, jackd (<< 3)
Depends: debconf | debconf-2.0,
         libjack-jackd2-0 (= ${binary:Version}),
         python3-dbus,
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Recommends: jackd2-firewire [amd64 i386 powerpc], libpam-modules, qjackctl
Suggests: jack-tools, meterbridge
Description: JACK Audio Connection Kit (server and example clients)
 JACK is a low-latency sound server, allowing multiple applications to
 connect to one audio device, and to share audio between themselves.
 .
 This package contains the daemon jackd as well as some example clients.

Package: libjack-jackd2-0
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: jackd2 (<< ${binary:Version}),
           jackd2 (>> ${binary:Version}),
           libjack-0.116,
           libjack-0.125,
           libjack0
Suggests: jackd2 (= ${binary:Version})
Provides: libjack-0.116, libjack-0.125
Replaces: libjack-0.116, libjack-0.125
Multi-Arch: same
Description: JACK Audio Connection Kit (libraries)
 JACK is a low-latency sound server, allowing multiple applications to
 connect to one audio device, and to share audio between themselves.
 .
 This package contains the shared libraries.

Package: jackd2-firewire
Architecture: amd64 i386 powerpc
Provides: jackd-firewire
Replaces: jackd-firewire
Conflicts: jackd-firewire
Depends: jackd2 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: JACK Audio Connection Kit (FFADO backend)
 JACK is a low-latency sound server, allowing multiple applications to
 connect to one audio device, and to share audio between themselves.
 .
 This package contains the IEEE1394 (FireWire) backend FFADO.

Package: libjack-jackd2-dev
Architecture: any
Section: libdevel
Multi-Arch: same
Depends: libjack-jackd2-0 (= ${binary:Version}), pkg-config, ${misc:Depends}
Conflicts: libjack-dev, libjack0.100.0-dev (<< 0.102.20-2)
Provides: libjack-dev, libjack-dev-session, libjack0.100.0-dev
Replaces: libjack0.71.2-0 (<< 0.75.0-1)
Description: JACK Audio Connection Kit (development files)
 JACK is a low-latency sound server, allowing multiple applications to
 connect to one audio device, and to share audio between themselves.
 .
 This package contains files needed for the development of JACK applications
 and an API reference.
